# Minimal bootstrap configuration.
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Intended to install a minimal bootstrap configuration
# that can be further installed by a configuration-management
# system such as Ansible.
#
# This is actually a bit of a hack; we shouldn't be using this at all,
# but rather having a bootstrap image that natively understands and
# can securly pull-down and execute configuration management instructions
# instead.
#
# However, we currently lack secure repository fetching capabilities, and
# we currently also lack the necessary verbs in Ansible to properly configure
# e.g. MD disk arrays and block-device partitions.
#
# So as a stop-gap, we're reusing debian-installer and partman.

# This debian-installer configuration:
# - Identifies the disks we should be using;
# - Sets up MD mirrors as appropriate;
# - Partitions the disks for the root filesystem.
# - Formats a new root filesystem.
# - Installs a set of authorized keys for the root user.
# - Installs SSH.
# - Installs the pre-requisties for running Ansible playbooks.
# - Configures networking to use DHCP.
#
# This version is suitable for Ceph storage hosts.
# It operates more dynamically than most auto-install scripts, as it tries to
# dynamically determine the locations of SSDs to install onto.

# DANGER: Do not run this install script on Ceph hardware which contains
#         data of value, as it will wipe all existing journals, rendering
#         the local OSDs useless.

# This configuration file will ONLY work if it is passed by URL on
# the kernel command line as "auto url=...", and WILL NOT WORK if
# is passed as "ks=...".

# Select system locale.
d-i debian-installer/locale string en_GB

# Select system keyboard layout.
d-i keymap select gb

# Is the local clock in UTC? Say 'true' unless you're dual-booting with
# another OS that can't cope with this. (e.g. Windows)
d-i clock-setup/utc boolean true

# System timezone
d-i time/zone string Europe/London

# Set system time using NTP.
d-i clock-setup/ntp boolean true
d-i clock-setup/ntp-server string {{ bes_ntp_servers | join(" ") }}

# We have to either set a password for the superuser, or make an
# unprivilged user account.  Don't make a new unprivileged account,
# and set the crypted root password string to 'x', i.e. "none valid".
{% if bes_keyboard_access_user is defined %}
d-i passwd/user-fullname string {{ bes_keyboard_access_user }}
d-i passwd/username string {{ bes_keyboard_access_username }} 
d-i passwd/user-password-crypted password {{ bes_keyboard_access_user_crypted_password }}
{% else %}
d-i passwd/make-user boolean false
d-i passwd/root-login boolean true
d-i passwd/root-password-crypted string x
{% endif %}

# Specify package mirror to use.
d-i mirror/protocol string http
d-i mirror/country string manual
d-i mirror/http/hostname string {{ bes_install_repo_server }}
d-i mirror/http/directory string {{ bes_install_repo_dir }}

# Specify suite to install
d-i mirror/suite string {{ bes_install_version }}

# Configure a layout using RAID.
d-i partman-auto/method string lvm

# Yes to lvm and overwrite what is there
d-i partman-lvm/confirm boolean true
d-i partman-lvm/confirm_nooverwrite boolean true

# You can choose one of the three predefined partitioning recipes:
# - atomic: all files in one partition
# - home:   separate /home partition
# - multi:  separate /home, /var, and /tmp partitions
d-i partman-auto/choose_recipe select atomic

# Use GPT.
d-i partman-basicfilesystems/choose_label string gpt
d-i partman-basicfilesystems/default_label string gpt
d-i partman-partitioning/choose_label string gpt
d-i partman-partitioning/default_label string gpt
d-i partman/choose_label string gpt
d-i partman/default_label string gpt

# Work non-interactively.
d-i partman-auto-lvm/no_boot boolean true
d-i partman-md/confirm boolean true
d-i partman-md/confirm_nochanges boolean true
d-i partman-md/confirm_nooverwrite boolean true
d-i partman-md/device_remove_md boolean true
d-i partman-lvm/device_remove_lvm boolean true
d-i partman-lvm/confirm boolean true
d-i partman-lvm/confirm_nooverwrite boolean true
d-i partman/confirm boolean true
d-i partman/choose_partition select Finish
d-i partman/confirm_write_new_label boolean true
d-i partman/confirm_nooverwrite boolean true
d-i partman-partitioning/confirm_write_new_label boolean true

# ... unless an error occurs, in which case be verbose.
d-i partman-auto-raid/error error
d-i partman-lvm/vgcreate_nosel error
d-i partman-lvm/commit_failed error
d-i partman-auto-lvm/unusable_recipe error

# Install GRUB.
d-i grub-installer/only_debian boolean true
d-i grub-installer/with_other_os boolean true
# Set a dummy string.  This should be overridden by the partman early_command above.
d-i grub-installer/bootdev string {{ bes_grub_dev }}

# Network information
d-i netcfg/get_hostname string dhcp-failed-to-supply-hostname
d-i netcfg/get_domain string error.error.error

# Automatically load (non-free) firmware if required.
d-i hw-detect/load_firmware boolean true

# Install the following packages over and above those required.
d-i pkgsel/include string openssh-server python

# Install root SSH keys.
d-i preseed/late_command string \
    echo "Running post-install script."; \
    echo "Installing user SSH keys..."; \
    {%- for user in bes_ssh_key_users %}

    in-target adduser {{ user }} --disabled-password --gecos "{{ user }}"; \
    in-target mkdir -p /home/{{ user }}/.ssh; \
    in-target chown {{ user }}:{{ user }} /home/{{ user }}/.ssh; \
    in-target chmod 700 /home/{{ user }}/.ssh; \
    echo -e "{{ lookup('file', bes_path_to_pub_keys + user + '.pub') }}\n" >> /target/home/{{ user }}/.ssh/authorized_keys; \
    in-target chown {{ user }}:{{ user }} /home/{{ user }}/.ssh/authorized_keys; \
    echo '{{ user }} ALL=(ALL) NOPASSWD: ALL' > /target/etc/sudoers.d/{{ user }}_sudoers; \

    {%- endfor %}

    echo "Finished adding users"

# Automatically reboot at the end.
d-i finish-install/reboot_in_progress note
